/*---------------------- C++ header file -----------------------
 Project: tEngine

   

 Developer: Pavel Bagretsov
 Website: http://gamedesign.narod.ru/
 EMail: gamedesign@narod.ru
--------------------------------------------------------------*/

#ifndef _TEFFECTS_H_
#define _TEFFECTS_H_

#include "..\tD3D\tD3D.h"

/*--------------------------------------------------------------
 
--------------------------------------------------------------*/
const int TEFFECTSMAXCOUNT = 1024;

/*--------------------------------------------------------------
 tEffects

   
--------------------------------------------------------------*/
class TENGINE_DLL tEffects : virtual public tD3D
{
public:
    tEffects();
    virtual ~tEffects();

    int LoadEffect(const char* name);
    void ReleaseEffect(int id);

    int BeginEffect(int id);
    void EndEffect(int id);

    void PassEffect(int id,int pass);
protected:
    struct tEFFECT
    {
        LPD3DXEFFECT effect;
        LPD3DXTECHNIQUE technique;
        string fileName;

        tEFFECT::tEFFECT()
        {
            effect = NULL;
            technique = NULL;
            fileName = "";
        }
    };

    vector<tEFFECT> m_vector; //  
    stack<int> m_stack; //   

    void Reset(void);
};

#endif _TEFFECTS_H_
