/*---------------------- C++ source file -----------------------
 Project: tEngine

     tEngine

 Developer: Pavel Bagretsov
 Website: http://gamedesign.narod.ru/
 EMail: gamedesign@narod.ru
--------------------------------------------------------------*/

#include "tEngine.h"

/*--------------------------------------------------------------
 tEngine::tEngine()

   
--------------------------------------------------------------*/
tEngine::tEngine()
{
}

/*--------------------------------------------------------------
 tEngine::~tEngine()

 
--------------------------------------------------------------*/
tEngine::~tEngine()
{
}

/*--------------------------------------------------------------
 tEngine::InitEngine()

  
--------------------------------------------------------------*/
void tEngine::InitEngine(void)
{
    //  log-
    tLogFile::OpenLogFile("tEngine.log");
}

/*--------------------------------------------------------------
 tEngine::ReleaseEngine()

  
--------------------------------------------------------------*/
void tEngine::ReleaseEngine(void)
{
    //  log-
    tLogFile::CloseLogFile();

    //  
    tRender::ReleaseRender();
}

/*--------------------------------------------------------------
 tEngine::RunEngine()

  
--------------------------------------------------------------*/
void tEngine::RunEngine(void)
{
    MSG msg;

    try
    {
        //  
        while(1)
            if(PeekMessage(&msg,NULL,0,0,PM_REMOVE))
            {
                if(msg.message==WM_QUIT) break;
                TranslateMessage(&msg);
                DispatchMessage(&msg);
            }
            else
                //  
                (*m_thread)();
    }
    catch(tError &error)
    {
        error.AddErrorHistory(" <-tEngine::RunEngine <-tEngine.dll");
        throw;
    }
}

/*--------------------------------------------------------------
 tEngine::SetEngineThread()

    
--------------------------------------------------------------*/
void tEngine::SetEngineThread(void (*thread)(void))
{
    //    
    m_thread = thread;
}

/*--------------------------------------------------------------
--------------------------------------------------------------*/
BOOL APIENTRY DllMain(HANDLE hModule,DWORD ul_reason_for_call,LPVOID lpReserved)
{
    switch(ul_reason_for_call)
    {
        case DLL_PROCESS_ATTACH:
        case DLL_THREAD_ATTACH:
        case DLL_THREAD_DETACH:
        case DLL_PROCESS_DETACH:
            break;
    }
    return TRUE;
}
