/*---------------------- C++ source file -----------------------
 Project: tEngine

  

 Developer: Pavel Bagretsov
 Website: http://gamedesign.narod.ru/
 EMail: gamedesign@narod.ru
--------------------------------------------------------------*/

#include "tFile.h"

/*--------------------------------------------------------------
 tFile::tFile()

   
--------------------------------------------------------------*/
tFile::tFile()
{
    m_file = NULL;
}

/*--------------------------------------------------------------
 tFile::~tFile()

 
--------------------------------------------------------------*/
tFile::~tFile()
{
    //  
    if(m_file)
        if(fclose(m_file))
            throw tError(__FILE__,__LINE__,"tFile::~tFile",
                         "Can't close file! / file - %s / flags - 0x%x",m_fileName,m_fileFlags);
    m_fileName.erase();
}

/*--------------------------------------------------------------
 tFile::OpenFile()

  
--------------------------------------------------------------*/
void tFile::OpenFile(const char* name,int flags)
{
    string openFlags;

    try
    {
        //  
        tFile::CloseFile();
    }
    catch(tError &error)
    {
        error.AddErrorHistory(" <-tFile::OpenFile");
        throw;
	}

    //   
    m_fileName = name;
    //  
    m_fileFlags = flags;

    //    
    if(m_fileFlags&TFILEREAD)
        openFlags = "r";
    if(m_fileFlags&TFILEWRITE)
        openFlags = "r+";
    if((m_fileFlags&TFILEWRITE)&&(m_fileFlags&TFILENEW))
        openFlags = "w";
    if((m_fileFlags&TFILEREAD)&&(m_fileFlags&TFILENEW))
        openFlags = "w+";
    if(m_fileFlags&TFILEBINARY)
        openFlags += "b";
    else
        openFlags += "t";

	//  
    m_file = fopen(m_fileName.c_str(),openFlags.c_str());
    if(!m_file)
        throw tError(__FILE__,__LINE__,"tFile::OpenFile",
                     "Can't open file! / file - %s / flags - 0x%x",m_fileName.c_str(),m_fileFlags);
}

/*--------------------------------------------------------------
 tFile::CloseFile()

  
--------------------------------------------------------------*/
void tFile::CloseFile(void)
{
    if(m_file)
    {
        if(fclose(m_file))
            throw tError(__FILE__,__LINE__,"tFile::CloseFile",
                         "Can't close file! / file - %s / flags - 0x%x",m_fileName,m_fileFlags);
        m_file = NULL;
        m_fileName.erase();
    }
}
