/*---------------------- C++ header file -----------------------
 Project: tEngine

    

 Developer: Pavel Bagretsov
 Website: http://gamedesign.narod.ru/
 EMail: gamedesign@narod.ru
--------------------------------------------------------------*/

#ifndef _TINDEXBUFFERS_H_
#define _TINDEXBUFFERS_H_

#include "..\tD3D\tD3D.h"

/*--------------------------------------------------------------
 
--------------------------------------------------------------*/
const int TINDEXBUFFERSMAXCOUNT = 1024;

/*--------------------------------------------------------------
  
--------------------------------------------------------------*/
enum {
    TINDEX16 = D3DFMT_INDEX16, // 16-
    TINDEX32 = D3DFMT_INDEX32, // 32-
};

/*--------------------------------------------------------------
 tIndexBuffers

    
--------------------------------------------------------------*/
class TENGINE_DLL tIndexBuffers : virtual public tD3D
{
public:
    tIndexBuffers();
    virtual ~tIndexBuffers();

    int LoadIndexBuffer(void* source,int size,int indexFormat);
    void ReleaseIndexBuffer(int id);

    void SetIndexBuffer(int id,int start);
protected:
    struct tINDEXBUFFER
    {
        LPDIRECT3DINDEXBUFFER8 buffer;
        DWORD indexFormat;

        tINDEXBUFFER::tINDEXBUFFER()
        {
            buffer = NULL;
            indexFormat = 0;
        }
    };

    vector<tINDEXBUFFER> m_vector;  //   
    stack<int> m_stack; //   
};

#endif _TINDEXBUFFERS_H_
