/*---------------------- C++ source file -----------------------
 Project: tEngine

  log-

 Developer: Pavel Bagretsov
 Website: http://gamedesign.narod.ru/
 EMail: gamedesign@narod.ru
--------------------------------------------------------------*/

#include "tLogFile.h"

/*--------------------------------------------------------------
 tLogFile::tLogFile()

   
--------------------------------------------------------------*/
tLogFile::tLogFile()
{
}

/*--------------------------------------------------------------
 tLogFile::~tLogFile()

 
--------------------------------------------------------------*/
tLogFile::~tLogFile()
{
}

/*--------------------------------------------------------------
 tLogFile::OpenLogFile()

  log-
--------------------------------------------------------------*/
void tLogFile::OpenLogFile(const char* name)
{
    try
    {
        //  
        tFile::OpenFile(name,TFILENEW|TFILEWRITE|TFILETEXT);
    }
    catch(tError &error)
    {
        error.AddErrorHistory(" <-tLogFile::OpenLogFile");
        throw;
    }
    tLogFile::LogMessage("----------------------- begin log ------------------------------\n");
}

/*--------------------------------------------------------------
 tLogFile::LogMessage()

    log-
--------------------------------------------------------------*/
void tLogFile::LogMessage(const char* message ...)
{
    va_list list;
    va_start(list,message);
    if(!m_file||vfprintf(m_file,message,list)<0)
        throw tError(__FILE__,__LINE__,"tLogFile::LogMessage",
                     "Fail to write to file! / file - %s / flags - 0x%x",m_fileName,m_fileFlags);
    va_end(list);
}

/*--------------------------------------------------------------
 tLogFile::CloseLogFile()

  log-
--------------------------------------------------------------*/
void tLogFile::CloseLogFile(void)
{
    tLogFile::LogMessage("----------------------- end log --------------------------------\n");
    try
    {
        //  
        tFile::CloseFile();
    }
    catch(tError &error) {
        error.AddErrorHistory(" <-tLogFile::CloseLogFile");
        throw;
    }
}
