/*---------------------- C++ header file -----------------------
 Project: tEngine

  

 Developer: Pavel Bagretsov
 Website: http://gamedesign.narod.ru/
 EMail: gamedesign@narod.ru
--------------------------------------------------------------*/

#ifndef _TRENDER_H_
#define _TRENDER_H_

#include "..\tTextures\tTextures.h"
#include "..\tVertexBuffers\tVertexBuffers.h"
#include "..\tIndexBuffers\tIndexBuffers.h"
#include "..\tEffects\tEffects.h"

/*--------------------------------------------------------------
 tRender

  
--------------------------------------------------------------*/
class TENGINE_DLL tRender : public tTextures,public tVertexBuffers,public tIndexBuffers,public tEffects
{
public:
    tRender();
    virtual ~tRender();

    void InitRender(int x,int y,int width,int height,int color = 0);
    void ReleaseRender(void);

    bool BeginRender(void);
    void EndRender(void);

    void DrawRender(int count);

    void SetVertexShaderConstant(int constantRegister,void* constantData,int constantCount);
    void SetPixelShaderConstant(int constantRegister,void* constantData,int constantCount);

    inline bool IsRenderSize(void) { return TWINDOWSIZE; };
    int GetRenderWidth(void);
    int GetRenderHeight(void);
protected:
    void Reset(void);
};

#endif _TRENDER_H_
