/*---------------------- C++ header file -----------------------
 Project: tEngine

    

 Developer: Pavel Bagretsov
 Website: http://gamedesign.narod.ru/
 EMail: gamedesign@narod.ru
--------------------------------------------------------------*/

#ifndef _TVERTEXBUFFERS_H_
#define _TVERTEXBUFFERS_H_

#include "..\tD3D\tD3D.h"

/*--------------------------------------------------------------
 
--------------------------------------------------------------*/
const int TVERTEXBUFFERSMAXCOUNT = 1024;

/*--------------------------------------------------------------
   
--------------------------------------------------------------*/
enum {
    TVERTEXXYZ = D3DFVF_XYZ, // 
    TVERTEXNORMAL = D3DFVF_NORMAL, // 
    TVERTEXDIFFUSE = D3DFVF_DIFFUSE, //  
    TVERTEXSPECULAR = D3DFVF_SPECULAR, //  
    //    
    TVERTEXTEX11 = D3DFVF_TEXCOORDSIZE1(0), //   
    TVERTEXTEX12 = D3DFVF_TEXCOORDSIZE1(1), //   
    TVERTEXTEX13 = D3DFVF_TEXCOORDSIZE1(2), //   
    TVERTEXTEX14 = D3DFVF_TEXCOORDSIZE1(3), //   
    //    
    TVERTEXTEX21 = D3DFVF_TEXCOORDSIZE2(0), //   
    TVERTEXTEX22 = D3DFVF_TEXCOORDSIZE2(1), //   
    TVERTEXTEX23 = D3DFVF_TEXCOORDSIZE2(2), //   
    TVERTEXTEX24 = D3DFVF_TEXCOORDSIZE2(3), //   
};

/*--------------------------------------------------------------
 tVertexBuffers

    
--------------------------------------------------------------*/
class TENGINE_DLL tVertexBuffers : virtual public tD3D
{
public:
    tVertexBuffers();
    virtual ~tVertexBuffers();

    int LoadVertexBuffer(void* source,int size,int vertexFormat);
    void ReleaseVertexBuffer(int id);

    void SetVertexBuffer(int id,int stream);
protected:
    struct tVERTEXBUFFER
    {
        LPDIRECT3DVERTEXBUFFER8 buffer;
        DWORD vertexFormat;

        tVERTEXBUFFER::tVERTEXBUFFER()
        {
            buffer = NULL;
            vertexFormat = 0;
        }
    };

    vector<tVERTEXBUFFER> m_vector; //   
    stack<int> m_stack; //   
};

#endif _TVERTEXBUFFERS_H_
